*** a/src/backend/postmaster/postmaster.c
--- b/src/backend/postmaster/postmaster.c
***************
*** 5622,5628 **** save_backend_variables(BackendParameters *param, Port *port,
  #ifndef HAVE_SPINLOCKS
  	param->SpinlockSemaArray = SpinlockSemaArray;
  #endif
! 	param->MainLWLockArray = MainLWLockArray;
  	param->ProcStructLock = ProcStructLock;
  	param->ProcGlobal = ProcGlobal;
  	param->AuxiliaryProcs = AuxiliaryProcs;
--- 5622,5628 ----
  #ifndef HAVE_SPINLOCKS
  	param->SpinlockSemaArray = SpinlockSemaArray;
  #endif
! 	param->MainLWLockArray = (LWLock*)MainLWLockArray;
  	param->ProcStructLock = ProcStructLock;
  	param->ProcGlobal = ProcGlobal;
  	param->AuxiliaryProcs = AuxiliaryProcs;
***************
*** 5853,5859 **** restore_backend_variables(BackendParameters *param, Port *port)
  #ifndef HAVE_SPINLOCKS
  	SpinlockSemaArray = param->SpinlockSemaArray;
  #endif
! 	MainLWLockArray = param->MainLWLockArray;
  	ProcStructLock = param->ProcStructLock;
  	ProcGlobal = param->ProcGlobal;
  	AuxiliaryProcs = param->AuxiliaryProcs;
--- 5853,5859 ----
  #ifndef HAVE_SPINLOCKS
  	SpinlockSemaArray = param->SpinlockSemaArray;
  #endif
! 	MainLWLockArray = (LWLockPadded*)param->MainLWLockArray;
  	ProcStructLock = param->ProcStructLock;
  	ProcGlobal = param->ProcGlobal;
  	AuxiliaryProcs = param->AuxiliaryProcs;
